Subject: bug#76294: `(cl-proclaim (inline foo))` vs `(defsubst foo ...)`

From: Stefan Monnier <[email-masked]>
Date: Fri, 14 Feb 2025 17:52:38 -0500

> May I ask what is the value proposition of
>
>     (defun foo () ...)
>     (cl-proclaim '(inline foo))
>
> over
>
>     (defsubst foo () ...)
>
> in Emacs Lisp code?

I never dared to touch this because I know I'm biased against those
thingies.  IOW, I'd be happy to deprecate such usage.  🙂

> I'm asking because running into this in cl-lib.el made me start to
> consider the below patch.

Looks good to me.  I suspect the reason behind the current code might be
that `defsubst` was introduced after cl.el got (and used) `proclaim`.

        Stefan